
// NLMS written in C for BSS

#define latency 3000000

typedef int control;

#define N 4

int main() {

  static int xn,yt,threshold;
  control i;
  int adapt,two_mu,pow,lambda,tmp;

  int h[N]; 
  int x[N];

  tmp = 0;
  x[0] = xn;
  for (i=0; i<N; i++) {
    tmp += x[i] * h[N-i-1];
  }

  adapt = two_mu * (yt - tmp);
  pow = (1 - lambda) * pow + lambda * xn * xn;

  // adaptation
  for (i=0; i<N; i++) {
    if (pow > threshold) {
      h[i] = h[i] + adapt * x[N-i-1];
    }
    else {
      h[i] = h[i];
    }
  }

  for (i=0; i<N-1; i++) {
    x[N-1-i] = x[N-2-i];
  }

  return tmp;
}
