///////////////////////////////////////////////////////////////

#include <systemc.h>
#include "display.h"

void display::entry(){
    int i = 0;
    sc_int<16> tmp1 = 0;
    sc_int<16> tmp2 = 0;

    wait(2);
    while(1) {
	//  Reading Data, and Counter i,j is counted up.
	wait_until(output_data_ready.delayed()==true);
	tmp1 = real_out.read();
	tmp2 = imag_out.read();
	cout << "Display : " << tmp1 << " " << tmp2 << " " 
	     << " at " << sc_clock::time_stamp() << endl;
	i++;
	if(i == 24) 	    sc_clock::stop();
        wait();
    }
}


// EOF
