///////////////////////////////////////////////////////////////

#include <systemc.h>
#include "stimulus.h"

void stimulus::entry() {
  sc_int<8>     send_value1;


  // sending some reset values
  reset.write(true);
  new_data.write(false);
  send_value1 = 0;
  wait(3);
  reset.write(false);
  // sending normal mode values
  while(true){
    wait_until(ready_for_data.delayed()==true);
    new_data.write( true );
    for(int i =0; i<4; i++) {
      data_in.write( send_value1 );
      cout << "Stimuli : " << send_value1 << " at "
	   << sc_clock::time_stamp() << endl;
      send_value1++;
      wait();
      new_data.write( false );
    }
  }
}

// EOF
