library IEEE,lib;
use IEEE.STD_LOGIC_ARITH.all;
use IEEE.STD_LOGIC_1164.all;
use lib.multx_types_pkg.all;

entity  multx is
	port(reset : in std_logic;
	     clk   : in std_logic;
	     a	   : in complex_16;
	     b     : in complex_16;
	     s	   : out complex_32);
end multx;

architecture a_multx of multx is

begin

	multx:process
	variable tmp : complex_32;
	variable var_a,var_b : complex_16;
	
	begin
	reset_loop :loop
	s.re<=(others=>'0');
	wait until clk'event and clk ='1';if (reset='0') then exit reset_loop;end if;
	s.im<=(others=>'0');
	wait until clk'event and clk ='1';if (reset='0') then exit reset_loop;end if;
	main: loop
		var_a:=a;
		var_b:=b;
		tmp.re:=(var_a.re*var_b.re)-(var_a.im*var_b.im);
		tmp.im:=(var_a.re*var_b.im)+(var_a.im*var_b.re);
		s.re<=tmp.re;
		wait until clk'event and clk ='1';if (reset='0') then exit reset_loop;end if;
		s.im<=tmp.im;
		wait until clk'event and clk ='1';if (reset='0') then exit reset_loop;end if;

	end loop main;
	end loop reset_loop;
	end process;
end a_multx;

configuration multx_cfg of multx is
	for a_multx
	end for;
end multx_cfg;
	