library IEEE;
use IEEE.STD_LOGIC_ARITH.all;
use IEEE.STD_LOGIC_1164.all;

package multx_types_pkg is

constant nb_bits :positive := 16;

type complex_16 is record
	re,im : signed(nb_bits-1 downto 0);
end record;

type complex_32 is record
	re,im : signed(2*nb_bits-1 downto 0);
end record;

end multx_types_pkg;