
// FFT written in C for BSS

#define latency 1000000

typedef int control;

#define N 4

int main()
{
  static int Xr[N];
  static int Xi[N];
  static int Yr[N];
  static int Yi[N];
  static int XXr[N];
  static int XXi[N];

  control i,ii,jj,ll;
  control NA,NE,N1,N2;

  static int Wr[N];
  static int Wi[N];
  int C,S,tr,ti;

  for (i=0; i<N; i++) {
    XXr[i] = Xr[i];
    XXi[i] = Xi[i];
  }

  N2 = N;

  while (N2 > 0) {

    N1 = N2;		
    N2 = N2 / 2;

    NE = N / N1;
    NA = 0;

    for (jj=0; jj<N2; jj++) {

      C = Wr[NA] ;
      S = Wi[NA] ;
      NA = NA + NE;
      ii = jj;

      while  (ii < N) {
	ll = ii + N2;
	if (N1 == N) {
	  tr = XXr[ii] - XXr[ll];
	  XXr[ii] = XXr[ii] + XXr[ll];
	  XXi[ii] = 0;
	  XXr[ll] = C * tr;
	  XXi[ll] = S * tr;
	}
	else {
	  tr = XXr[ii] - XXr[ll];
	  ti = XXi[ii] - XXi[ll];
	  XXr[ii] = XXr[ii] + XXr[ll];
	  XXi[ii] = XXi[ii] - XXi[ll];
	  XXr[ll] = C * tr + S * ti;
	  XXi[ll] = C * ti - S * tr;
	}
	ii = ii + N1;
      }
    }
  }

  for (i=0; i<N; i++) {
    Yr[i] = XXr[i];
    Yi[i] = XXi[i];
  }
}
