// cmult.cc implementation file

#include "systemc.h"
#include "cmult_rtl.h"

void cmult_rtl :: entry()
{
   sc_int<8> a, b, c, d;

   //Initialize and reset if reset asserts
   if (reset.read()==true){
   	real_out.write(0);
	imag_out.write(0);
	}
	else{
     // Read four data values from input port
     a = A.read();
     b = B.read();
     c = C.read();
     d = D.read();
     //Calculate and write output ports
     real_out.write(a * c - b * d);
     imag_out.write(a * d + b * c);
	}
}
