library IEEE;
use IEEE.STD_LOGIC_ARITH.all;
use IEEE.STD_LOGIC_1164.all;


entity  fir16 is
	port(	xn : IN INTEGER RANGE 0 to 255; 
		yn : OUT INTEGER RANGE 0 to 65535;
		clk, rst : IN STD_LOGIC );

end fir16;

architecture behavioral_fir16 of fir16 is

	-- Constantes, types et signaux
	CONSTANT N: INTEGER := 16; -- Size of the filter
	TYPE vector IS ARRAY (0 TO N-1) OF INTEGER RANGE 0 to 255;
	CONSTANT H : vector := (2,4,8,16,32,34,45,67,
				67,45,34,32,16,8,4,2);

begin

	main:process
	
		-- Variables
		VARIABLE X : 	vector;
		VARIABLE tmp : 	INTEGER RANGE 0 TO 65535;		
	
		ATTRIBUTE dont_unroll : BOOLEAN;
		ATTRIBUTE dont_unroll OF filtrage_loop : LABEL IS TRUE;
		-- Vous devez nommer la boucle principale de calcul filtrage_loop

	begin

	rst_loop : loop  -- rst state 1

	wait until clk'event and clk = '1'; 
	if rst = '1' then exit rst_loop; 
	end if;

	main_loop: loop



		-- Filtrage et evolution du signal


		
		wait until (clk'event and clk='1'); 
		EXIT rst_loop when rst='1';	end loop main_loop; 

	end loop rst_loop;

	end process main;
	
end behavioral_fir16;

